﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using System.Runtime.InteropServices; 

namespace Hitags_Demo
{
    delegate void del_ShowMsg(string msg);
    public partial class Form1 : Form
    {
        public static string isstr = "";
        public static string isml = "";
        public int Formshow = 0;
        public int Reclb = 0;
        public int Readlb = 0;
        [DllImport("user32.dll", EntryPoint = "keybd_event")]
        public static extern void keybd_event(
            byte bVk,
            byte bScan,
            int dwFlags,
            int dwExtraInfo
        ); 
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            EnableControls();
        }
        private void EnableControls()
        {
            // 基于串口的打开与否，设置控件状态
            button2.Enabled = serialPort1.IsOpen && comboBox2.SelectedIndex == 2;
            button3.Enabled = serialPort1.IsOpen && comboBox2.SelectedIndex == 2;
            button6.Enabled = serialPort1.IsOpen && comboBox2.SelectedIndex != 2;
            checkBox1.Enabled = serialPort1.IsOpen;
            if (serialPort1.IsOpen) button1.Text = "Close";
            else button1.Text = "Open";
        }
        private void init()
        {
            if (checkBox1.Checked)
            {
                isml = "0200020E010D03";
            }
            else
            {
                isml = "0200020E020E03";
            }
            Reclb = 1;
            SendData();
            int i;
            i = comboBox2.SelectedIndex;
            switch (i)
            {
                case 0:
                    isml = "0200020D010E03";
                    Readlb = 0;
                    break;
                case 1:
                    isml = "0200020D020D03";
                    Readlb = 0;
                    break;
                case 2:
                    isml = "0200020D030C03";
                    Readlb = 1;
                    break;
                default:
                    break;
            }
          //  timeDelay(200);
            Thread.Sleep(200);
            Reclb = 1;
            SendData();
        }

        private void ShowMsg(string msg)
        {
            if (msg != "")
            {
                textBox3.AppendText(msg);
                textBox3.SelectionStart = textBox1.TextLength;
                textBox3.ScrollToCaret();
            }
        }

        private byte[] HexStringToByteArray(string s)
        {
            s = s.Replace(" ", "");
            byte[] buffer = new byte[s.Length / 2];
            for (int i = 0; i < s.Length; i += 2)
                buffer[i / 2] = (byte)Convert.ToByte(s.Substring(i, 2), 16);
            return buffer;
        }
        private string ByteArrayToHexString(byte[] data)
        {
            StringBuilder sb = new StringBuilder(data.Length * 3);
            foreach (byte b in data)
                sb.Append(Convert.ToString(b, 16).PadLeft(2, '0').PadRight(3, ' '));
            return sb.ToString().ToUpper();
        }
        private void SendData()
        {
            // 转换用户十六进制数据到字节数组
            byte[] data = HexStringToByteArray(isml);
            //MessageBox.Show(isml);
            isml = "";
            // 发送数据到串口
            serialPort1.Write(data, 0, data.Length);
        }
        private void timeDelay(int iInterval)
        {
            DateTime now = DateTime.Now;
            while (now.AddMilliseconds(iInterval) > DateTime.Now)
            {
            }
            return;
        }

        private void serialPort1_DataReceived(object sender, System.IO.Ports.SerialDataReceivedEventArgs e)
        {
            timeDelay(50);
            int bytes = serialPort1.BytesToRead;

            // 创建字节数组
            byte[] buffer = new byte[bytes];

            // 读取缓冲区的数据到数组
            serialPort1.Read(buffer, 0, bytes);
            string data = ByteArrayToHexString(buffer);
            string s = "";
            int j = 0;
            DateTime dt = DateTime.Now;
            string lstime = "",showText = "" ;
            lstime = dt.ToString();
            isstr += data;
            isstr = isstr.Replace(" ", "");
            if (Reclb == 1)
            {
                Reclb = 0;
                isstr = "";
            }
            else
            {
                if (isstr.Substring(0, 6) == "020002" && isstr.Substring(isstr.Length - 2, 2) == "03")
                {
                    Reclb = 0;
                    isstr = "";
                }
                else
                {
                    if (Readlb == 0)
                    {
                        
                        for (int k = 0; k < isstr.Length; k =k + 2)
                        {

                            s += ((char)byte.Parse(isstr.Substring(k, 2), System.Globalization.NumberStyles.AllowHexSpecifier)).ToString();
                        }
                        
                        if (Formshow == 0)
                        {
                            showText += "Card Number:" + s + "    " + lstime + "\r\n";
                            Invoke(new del_ShowMsg(ShowMsg), showText);
                        }
                        else
                        {
                            s += "&" + lstime;
                            byte[] array = System.Text.Encoding.ASCII.GetBytes(s);
                            for (int i = 0; i < array.Length; i++)
                            {
                                j = (int)(array[i]);
                                switch (j)
                                {
                                    case 38:
                                        keybd_event(9, 0, 0, 0);
                                        keybd_event(9, 0, 2, 0);
                                        break;
                                    case 45:
                                        keybd_event(109, 0, 0, 0);
                                        keybd_event(109, 0, 2, 0);
                                        break;
                                    case 58:
                                        keybd_event(16, 0, 0, 0);
                                        keybd_event(186, 0, 0, 0);
                                        keybd_event(16, 0, 2, 0);
                                        keybd_event(186, 0, 2, 0);
                                        break;
                                    default:
                                        if (j > 64 && j < 91)
                                        {
                                            keybd_event(16, 0, 0, 0);
                                            keybd_event(array[i], 0, 0, 0);
                                            keybd_event(array[i], 0, 2, 0);
                                            keybd_event(16, 0, 2, 0);
                                        }
                                        else
                                        {
                                            keybd_event(array[i], 0, 0, 0);
                                            keybd_event(array[i], 0, 2, 0);
                                        }
                                        break;
                                }

                            }
                            keybd_event(13, 0, 0, 0);
                            keybd_event(13, 0, 2, 0);
                        }
                        isstr = "";
                       
                    }
                    else
                    {

                        //if (Reclb == 2)
                        //{
                        //    textBox3.Text += "页面数据：" + isstr.Substring(6, 8) + "\r\n";
                            
                        //}
                        //else
                        //{
                        //    textBox3.Text += "写页面数据成功！" + "\r\n";
                        //}
                        //textBox3.Text += isstr + "\r\n";
                    }
                }
            }

        }

        private void button4_Click(object sender, EventArgs e)
        {

        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
            {
                isml = "0200020E010D03";
            }
            else
            {
                isml = "0200020E020E03";
            }
            Reclb = 1;
            SendData();
        }

        private void comboBox2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int i;
            i = comboBox2.SelectedIndex;
            switch (i)
            {
                case 0:
                    isml = "0200020D010E03";
                    Readlb = 0;
                    break;
                case 1:
                    isml = "0200020D020D03";
                    Readlb = 0;
                    break;
                case 2:
                    isml = "0200020D030C03";
                    Readlb = 1;
                    break;
                default:
                    break;
            }
            Reclb = 1;
            SendData();
            EnableControls();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (serialPort1.IsOpen) serialPort1.Close();
            else
            {
                serialPort1.PortName = comboBox1.Text;
                serialPort1.BaudRate = 9600;
                serialPort1.Open();
                init();
            }
            EnableControls();
        }

        private void button4_Click_1(object sender, EventArgs e)
        {
            textBox3.Text = "";
        }

        private void button5_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DateTime dt = DateTime.Now;
            string lstime = "",showText = "";
            lstime = dt.ToString();
            isml = "0201" + textBox1.Text + "00000003";
            Reclb = 2;
            SendData();
            Thread.Sleep(400);
            if (isstr.Length < 14)
            {
                showText += "False...    " + lstime + "\r\n";
            }
            else
            {
                showText += "Card Data:" + isstr.Substring(6, 8) + "    " + lstime + "\r\n";
            }
            Invoke(new del_ShowMsg(ShowMsg), showText);
            isstr = "";
            Reclb = 0;
        }

        private void button3_Click(object sender, EventArgs e)
        {
            DateTime dt = DateTime.Now;
            string lstime = "", showText = "";
            lstime = dt.ToString();
            isml = "0202" + textBox1.Text + textBox2.Text;
            Reclb = 3;
            SendData();
            Thread.Sleep(400);
            if (isstr.Length == 0)
            {
                showText += "False...    " + lstime + "\r\n";
            }
            else
            {
                showText += "Success...    " + lstime + "\r\n";
            }
            Invoke(new del_ShowMsg(ShowMsg), showText);
            isstr = "";
            Reclb = 0;
        }

        private void button6_Click(object sender, EventArgs e)
        {
            if (Formshow == 0)
            {
                this.Visible = false;
                this.ShowInTaskbar = false;  //不显示在系统任务栏
                notifyIcon1.Visible = true;  //托盘图标可见
                Formshow = 1;
            }
        }

        private void notifyIcon1_MouseDoubleClick(object sender, MouseEventArgs e)
        {

        }

        private void notifyIcon1_DoubleClick(object sender, EventArgs e)
        {
            if (Formshow == 1)
            {
                this.Visible = true;
                this.ShowInTaskbar = true;  //显示在系统任务栏
                //  this.WindowState = FormWindowState.Normal;  //还原窗体
                notifyIcon1.Visible = false;  //托盘图标隐藏
                Formshow = 0;
            }
        }
    }
}